<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.0/dist/css/bootstrap.min.css" integrity="sha384-B0vP5xmATw1+K9KRQjQERJvTumQW0nPEzvF6L/Z6nronJ3oUOFUFpCjEUQouq2+l" crossorigin="anonymous"/>
	<title>Bootstrap - Flex</title>
</head>
<body>

	<div class="text-center">
		<h1>Bootstrap Flex</h1>
		<p>Use d-flex class to create a flex container and tranform direct children into flex items</p>

		<!-- d-flex -->
		<!-- we use d-flex to easily align our elements vertically (column) or horizontally (row)-->

		<h2>Centering Elements</h2>

		<h3>Centering flex-column without align-items-center</h3>
		<div style="height: 500px" class="bg-secondary p-3 justify-content-center d-flex flex-column">
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex Item A</div>
		</div>

		<h3>Centering flex-column with align-items-center</h3>
		<div style="height: 500px" class="bg-secondary p-3 justify-content-center align-items-center d-flex flex-column">
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex Item A</div>
		</div>

		<h2>Flex Row</h2>
		<!-- we use flex-row for horizintal alignment -->
		<div class="bg-dark p-3 d-flex flex-row">
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Flex Row Center</h2>
		<div class="bg-dark p-3 d-flex flex-row justify-content-center">
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Flex Row Reverse</h2>
		<div class="bg-dark p-3 d-flex flex-row-reverse">
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Creating Space Between Elements</h2>
		<!-- by default when we are using d-flex our elements aligment are based in flex-row -->
		<div class="bg-dark p-3 d-flex justify-content-around">
			<div class="p-3 bg-success col-md-2">Flex Item A</div>
			<div class="p-3 bg-warning col-md-2">Flex Item B</div>
			<div class="p-3 bg-danger col-md-2">Flex Item C</div>
		</div>

		<h2>Flexbox With Margin</h2>
		<div class="bg-dark p-3 d-flex">
			<div class="p-3 bg-success mr-auto">Logo</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
			<div class="p-3 bg-primary">Flex Item D</div>
		</div>

		<h2>Nested Flex Elements</h2>
		<!-- when we don't declare/include any screen size, by default it works like sm -->
		<!-- sm = small upto the next sizes -->
		<!-- md = medium upto the next sizes -->
		<!-- lg = large upto the next sizes -->
		<div class="bg-dark p-3 d-sm-block d-md-flex" >
			<div class="p-3 bg-success mr-auto">Flex Item A</div>
			<div class="w-50 d-sm-block d-md-flex justify-content-between">
				<div class="p-3 bg-warning">Flex Item B.1</div>
				<div class="p-3 bg-danger">Flex Item B.2</div>
				<div class="p-3 bg-primary">Flex Item B.3</div>
			</div>
		</div>
	</div>










	<h1 class="text-center">Mini Activity</h1>

	<!-- Mini Activity 1 -->

	<!-- The elements should be aligned horizontally if the device size is medium or large -->
	<!-- While in small devices it should be aligned vertically -->


	<div class="mt-5 mb-5 justify-content-around ml-3 mr-3 d-flex">

		<div class="col-sm row-md-4 text-center">
			<img class="img-fluid" src="images/blue.png">
			<div>I'm a blue photo</div>
		</div> 

		<div class="col-sm row-md-4 text-center">
			<img class="img-fluid" src="images/red.png">
			<div>I'm a red photo</div>
		</div> 

		<div class="col-sm row-md-4 text-center">
			<img class="img-fluid" src="images/green.png">
			<div>I'm a green photo</div>
		</div> 

	</div>



	<!-- Mini Activity 2 -->
	<!-- 1.A Align all blue horizontally if medium to large devices -->
	<!-- 1.B Align all green horizontally if medium to large devices -->
	<!-- 1.A Align all blue vertically if medium to large devices -->
	<!-- 1.B Align all green vertically if medium to large devices -->

	<div class="mb-4 d-flex">

      <div class="container-fluid row-md align-item-center">
          <div class="align-items-center justify-content-center">
              <img width="150" class="mr-3 mb-3 " src="images/blue.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/blue.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/blue.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/blue.png"/>
          </div>
          <div class="align-items-center justify-content-center row-md">
              <img width="150" class="mr-3 mb-3 " src="images/green.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/green.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/green.png"/>
              <img width="150" class="mr-3 mb-3 " src="images/green.png"/>
          </div>
      </div>
		





<script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/popper.js@1.14.7/dist/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.3.1/dist/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>

</body>
</html>
